(ns wanijo.schema.view
  (:require [hiccup.form :as hform]
            [ring.util.anti-forgery :refer [anti-forgery-field]]
            [wanijo.framework.view :as view]
            [wanijo.framework.form :as form]
            [wanijo.schema.domain :as domain]))

(def new-form
  {:fields {:schema-name {:label "Nimi"
                          :required true
                          :spec :wanijo.domain.schema/name}}})

(defn overview! [req]
  (let [session (:session req)
        uuid (:uuid session)
        schemas (domain/all-created-by! uuid)]
    (view/layout!
     :session session
     :content
     [[:h1 "Ali jaki ijo"]
      [:table
       [:thead
        [:tr
         [:th "Nimi"]
         [:th "Tenpo kama"]]]
       [:tbody
        (for [schema schemas]
          [:tr
           [:td
            [:a {:href (str "/schema/" (:uuid schema))}
             (:name schema)]]
           [:td (:created_at schema)]])]]
      [:h1 "Pali sin e jaki ijo"]
      (hform/form-to
       [:post "/schema/new"]
       (form/field new-form :schema-name req)
       (hform/submit-button "Pali")
       (anti-forgery-field))])))

(defn show-schema! [schema session]
  (view/layout!
   :session session
   :content
   [[:h1 "Jaki ijo " (:name schema)]]))
